#include <algorithm>
#include <cctype>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstring>
#include <iomanip>
#include <iostream>
#include <list>
#include <map>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <string>
#include <utility>

using namespace std;

#define DEBUG(x) cout << ">>> " << #x << " : " << x << endl;
#define REP(i,a) for (int i = 0; i < (a); ++i)
#define FOR(i,a,b) for (int i = (a); i <= (b); ++i)
#define FORD(i,a,b) for (int i = (a); i >= (b); --i)
inline bool EQ(double a, double b) { return fabs(a-b) < 1e-9; }
const int INF = 1<<29;

typedef long long ll;

#define maxN 1005

int n,c;
int u,v,w;
vector<int> edges[maxN];
vector<ll> prizes[maxN];
int father[maxN];
ll fatherprize[maxN];
ll sum;

ll comp(int u){
	if(edges[u].size()==1) return fatherprize[u];
	ll ans = 0;
	REP(i,edges[u].size()){
		if(edges[u][i]==father[u]) continue;
		father[edges[u][i]]=u;
		fatherprize[edges[u][i]]=prizes[u][i];
		ans += comp(edges[u][i]);
	}
	ans = min(ans,fatherprize[u]);
	return ans;
}

int main() {
	while(scanf("%d%d",&n,&c)==2){
		sum = 0;
		c--;
		REP(i,n){ edges[i].clear(); prizes[i].clear(); }
		REP(i,n-1){
			scanf("%d%d%d",&u,&v,&w);
			u--; v--;
			edges[u].push_back(v); edges[v].push_back(u);
			prizes[u].push_back(w); prizes[v].push_back(w);
		}

		REP(i,edges[c].size()){
			father[edges[c][i]]=c;
			fatherprize[edges[c][i]]=prizes[c][i];
			sum += comp(edges[c][i]);
		}
		printf("%lld\n",sum);
	}
		
	return 0;
}
